

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable AutoUpdate 0
    variable AutoRate 2000
    variable Counters {}
    variable Rates {}

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

#     access procedures

    proc do_counters {} {
        global errorCode errorInfo

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetCounters} m]
        if {$rc != 0} {
            InsertLog "COUNTERS returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "COUNTERS returned $m"
            return $m
        }
    }

    proc do_rates {} {
        global errorCode errorInfo

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetRates} m]
        if {$rc != 0} {
            InsertLog "RATES returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "RATES returned $m"
            return $m
        }
    }

   proc do_clearstats {} {
        global errorCode errorInfo

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoOption ClearStats 0} m]
        if {$rc != 0} {
            InsertLog "CLEARSTATS returned with an error\n$m\n$errorCode\n$errorInfo"
        }
   }

   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable AutoUpdate

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag; AutoUpdate=$AutoUpdate"
   }

   proc do_Redisplay {} {
       variable Counters
       variable Rates

       set Counters {}
       foreach item [split [do_counters]] {lappend Counters $item}
       set Rates {}
       foreach item [split [do_rates]] {lappend Rates $item}

   }


     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable AutoUpdate 

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   REDISPLAY {do_Redisplay}
                   AUTO     {
                     switch [lindex $cgidata 3] {
                         on  {set AutoUpdate 1}
                         off -
                         default {set AutoUpdate 0}
                     }
                   }
                   CLRSTATS {do_clearstats; do_Redisplay}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }

           }
       }
    }

    do_Redisplay

}   ;# end of if {$started == 0}

